######################################################################
# constants and built-in defaults for ZWiki

DEFAULT_PAGE_TYPE = 'structuredtext'
DISABLE_JAVASCRIPT = 1
LARGE_FILE_SIZE = 1024*1024

# built-in DTML defaults - to override these, define any of the
# following as DTML methods (python scripts, properties ?):
#
# standard_wiki_header
# standard_wiki_footer
# standard_wiki_page
# editform
# backlinks

import DocumentTemplate
from DocumentTemplate import HTMLFile
#from Globals import HTMLFile

# ? the ramifications of when and where this dtml gets executed are
# not yet clear ...
# would like to move these to separate files.. how do I define
# these in such a way that "<dtml-var id>" will work at runtime ?

#default_wiki_page = DocumentTemplate.HTMLFile('dtml/default_wiki_page', globals())

default_wiki_page = DocumentTemplate.HTML(source_string="")

# also would prefer not to inline the header in editform & backlinks

#default_wiki_header = HTMLFile('dtml/default_wiki_header', globals())
#default_wiki_footer = HTMLFile('dtml/default_wiki_footer', globals())
#default_editform =    HTMLFile('dtml/default_editform', globals())
#default_backlinks =   HTMLFile('dtml/default_backlinks', globals())

default_wiki_header = DocumentTemplate.HTML(source_string=\
'''<HTML>
<HEAD>
<TITLE><dtml-var "aq_parent.title"><dtml-var id></TITLE>
</HEAD>
<BODY BGCOLOR="#FFFFFF">
<table width="100%" border="0" cellspacing="0" cellpadding="3"  bgcolor="#dddddd">
<tr>
<td valign="bottom">
<h1>
<a href="&dtml-wiki_url;/"><img src="/misc_/ZWiki/ZWikiPage_icon.gif" height=32 width=32 border=0 valign="bottom" alt="to FrontPage"></a>
<a href="&dtml-page_url;/backlinks"><dtml-var id></a>
</h1>
</td>
<td valign="top" align="right"  bgcolor="#dddddd">&nbsp;
</td>
</tr>
</table>
<p>
<!-- end of default_wiki_header -->

''')

default_wiki_footer = DocumentTemplate.HTML(source_string=\
'''
<!-- start of default_wiki_footer -->
<p>
<table width="100%" border="0" cellspacing="0" cellpadding="3" bgcolor="#dddddd">
<tr>
<td valign="middle" align="left"><em><small><span style="color:gray">
Last edited <dtml-var bobobase_modification_time>
</span></small></em></td>
<td valign="middle" align="right">
<a href="&dtml-wiki_url;/<dtml-var id url_quote>/editform">Edit this page</a>
</td>
</tr></table>
</BODY>
</HTML>
''')

default_editform = DocumentTemplate.HTML(source_string=\
'''<HTML>
<HEAD>
<TITLE><dtml-var "aq_parent.title"><dtml-var id> edit form</TITLE>
</HEAD>
<BODY BGCOLOR="#FFFFFF">
<table width="100%" border="0" cellspacing="0" cellpadding="3"  bgcolor="#dddddd">
<tr>
<td valign="bottom">
<h1>
<a href="&dtml-wiki_url;/"><img src="/misc_/ZWiki/ZWikiPage_icon.gif" height=32 width=32 border=0 valign="bottom" alt="to FrontPage"></a>
<a href="&dtml-page_url;/backlinks"><dtml-var id></a>
</h1>
</td>
<td valign="top" align="right"  bgcolor="#dddddd">&nbsp;
</td>
</tr>
</table>
<p>
<!-- end of default_wiki_header -->

<FORM METHOD="POST" ACTION="&dtml-wiki_url;/<dtml-var oldid url_quote>/edit" ENCTYPE="multipart/form-data">
<input name=timeStamp type=hidden value="&dtml-editTimestamp;">
<input name=page type=hidden value="&dtml-id;">

<div align="center">
<TEXTAREA WRAP="virtual" NAME="text" ROWS=<dtml-var zwiki_height missing=15> COLS=<dtml-var zwiki_width missing=60>>
<dtml-var text html_quote></TEXTAREA>
</div>
<br>
<table width="100%" border="0" cellspacing="0" cellpadding="3" bgcolor="#dddddd">
<tr>
<td valign="middle" align="left"><em><small><span style="color:gray">
Using built-in ui.. for more options, add a Zwiki Web.
</span></small></em></td>
<td valign="middle" align="right">
<INPUT TYPE="submit" NAME="<dtml-var action>" VALUE=" <dtml-var action> <dtml-var id> ">
<dtml-comment>give some indication of permissions</dtml-comment>
<dtml-if "(action == 'Create' and not AUTHENTICATED_USER.has_permission('Add ZWiki Pages',aq_parent)) or
(action == 'Change' and not AUTHENTICATED_USER.has_permission('Zwiki: Edit pages',this()))">
<br><em>(login required)</em>
</dtml-if>
</td>
</tr>
</table>
<br>
</FORM>
</body>
</html>
''')

default_backlinks = DocumentTemplate.HTML(source_string=\
'''<HTML>
<HEAD>
<TITLE><dtml-var "aq_parent.title"><dtml-var id> backlinks</TITLE>
</HEAD>
<BODY BGCOLOR="#FFFFFF">
<table width="100%" border="0" cellspacing="0" cellpadding="3"  bgcolor="#dddddd">
<tr>
<td valign="bottom">
<h1>
<a href="&dtml-wiki_url;/"><img src="/misc_/ZWiki/ZWikiPage_icon.gif" height=32 width=32 border=0 valign="bottom" alt="to FrontPage"></a>
<a href="&dtml-page_url;/backlinks"><dtml-var id></a>
</h1>
</td>
<td valign="top" align="right"  bgcolor="#dddddd">&nbsp;
</td>
</tr>
</table>
<p>
<!-- end of default_wiki_header -->

<dtml-let thispage=id>
The following pages link to <a href="&dtml-page_url;"><dtml-var id></a>:
<p>
<dtml-in "aq_parent.objectValues(spec='ZWiki Page')" sort=id>
<dtml-unless "_.string.find(_.getitem('sequence-item').raw,thispage) == -1">
<a href="&dtml-wiki_url;/<dtml-var "_.getitem('id')()" url_quote>"><dtml-var "_.getitem('id')()"></a><br>
</dtml-unless>
</dtml-in>
</dtml-let>
</body>
</html>
''')

default_subscribeform = DocumentTemplate.HTML(source_string=\
'''<HTML>
<HEAD>
<TITLE><dtml-var "aq_parent.title"><dtml-var id> subscription</TITLE>
</HEAD>
<BODY BGCOLOR="#FFFFFF">
<table width="100%" border="0" cellspacing="0" cellpadding="3"  bgcolor="#dddddd">
<tr>
<td valign="bottom">
<h1>
<a href="&dtml-wiki_url;/"><img src="/misc_/ZWiki/ZWikiPage_icon.gif" height=32 width=32 border=0 valign="bottom" alt="to FrontPage"></a>
Mail subscription
</h1>
</td>
<td valign="top" align="right"  bgcolor="#dddddd">&nbsp;
</td>
</tr>
</table>
<p>
<!-- end of header -->

<!-- remember email address like on UserOptions -->
<dtml-if emailchanged>
<dtml-call "RESPONSE.setCookie('email',REQUEST.email,path='/',expires=(ZopeTime() + 365).rfc822())">
</dtml-if>

<FORM METHOD="POST" ACTION="&dtml-page_url;/subscribeform" ENCTYPE="multipart/form-data">

You can subscribe to this page or to the whole wiki.
Subscribers receive a copy of comments via email
(but not general edits, unless enabled by the site admin).
Or return to <a href="&dtml-page_url;">&dtml-id;</a>.

<br><br>

Your email address:
<input name="email" type="text" value="<dtml-var email missing>" size=30>
<input name="emailchanged" type="hidden" value="1">
<INPUT TYPE="submit" NAME="../subscribeform:method" VALUE=" Change ">
<br><br>

<table width="100%" cellpadding="2" cellspacing="1" border="0">
<dtml-if email>
<tr valign="top">
<td valign="top" width="50%"
<dtml-if "isSubscriber(email)">
bgcolor="#88ff88"
<dtml-else>
bgcolor="#ff7777"
</dtml-if>
>
You are currently
<dtml-if "isSubscriber(email)">
<b>subscribed</b><br>
<dtml-else>
not subscribed<br>
</dtml-if>
to this page.
<br>
<dtml-if "isSubscriber(email)">
<INPUT TYPE="submit" NAME="../unsubscribe:method" VALUE=" Unsubscribe from &dtml-id; " style="font-weight:bold">
<dtml-else>
<INPUT TYPE="submit" NAME="../subscribe:method" VALUE=" Subscribe to &dtml-id; " style="font-weight:bold">
</dtml-if>
<br>
</td>
<td valign="top" width="50%"
<dtml-if "isWikiSubscriber(email)">
bgcolor="#88ff88"
<dtml-else>
bgcolor="#ff7777"
</dtml-if>
>
You are currently
<dtml-if "isWikiSubscriber(email)">
<b>subscribed</b><br>
<dtml-else>
not subscribed<br>
</dtml-if>
to the whole wiki.
<br>
<dtml-if "isWikiSubscriber(email)">
<INPUT TYPE="submit" NAME="../wikiUnsubscribe:method" VALUE=" Unsubscribe from the whole wiki " style="font-weight:bold">
<dtml-else>
<INPUT TYPE="submit" NAME="../wikiSubscribe:method" VALUE=" Subscribe to the whole wiki " style="font-weight:bold">
</dtml-if>
<br>
</td>
</tr>

<tr>
<td>
<dtml-in "otherPageSubscriptionsFor(email)" prefix=x>
<dtml-if sequence-start>
You are subscribed to these other pages: <br>
</dtml-if>
<a href="../&dtml.url_quote-x_sequence_item;/subscribeform?email=&dtml.url_quote-email;"
><dtml-var x_sequence_item></a>
<dtml-else>
<dtml-comment>
You have no other page subscriptions.
</dtml-comment>
</dtml-in>
</td>
<td>
</td>
</tr>
</dtml-if>

<tr>
<td valign="top" width="50%"
<br>
<dtml-var id> subscribers:
<br>
<dtml-comment>
<dtml-let n="subscriberCount()">
<dtml-if n>
<dtml-in "_.string.split(subscriberList(),' ')">
<dtml-var "_.string.split(_['sequence-item'],'@')[0]"><br>
</dtml-in>
</dtml-if>
</dtml-let>
</dtml-comment>
<dtml-in subscriberList prefix=x>
<dtml-var "_.string.split(x_sequence_item,'@')[0]"><br>
</dtml-in>
</td>
<td valign="top" width="50%"
<br>
wiki subscribers:
<br>
<dtml-comment>
<dtml-let n="wikiSubscriberCount()">
<dtml-if n>
<dtml-in "_.string.split(wikiSubscriberList(),' ')">
<dtml-var "_.string.split(_['sequence-item'],'@')[0]"><br>
</dtml-in>
</dtml-if>
</dtml-let>
</dtml-comment>
<dtml-in wikiSubscriberList prefix=x>
<dtml-var "_.string.split(x_sequence_item,'@')[0]"><br>
</dtml-in>
</td>
</tr>

</table>

<br>
<dtml-comment>
<INPUT TYPE="submit" NAME="..:method" VALUE=" Return to &dtml-id; ">
</dtml-comment>

</FORM>
</body>
</html>
''')

